/***************************************************************************
 *   Copyright (C) 2011 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef NOPVIEWGLWIDGET_H
#define NOPVIEWGLWIDGET_H

#include <QGLWidget>
#include <QImage>
#include <QMouseEvent>
#include <QWheelEvent>

class NopViewGLWidget : public QGLWidget
{
    Q_OBJECT
public:
    explicit NopViewGLWidget(QWidget *parent = 0);
    ~NopViewGLWidget();
protected:
    virtual void initializeGL();
    virtual void paintGL();
    virtual void resizeGL(int width,int height);
    virtual void mousePressEvent(QMouseEvent *event);
    virtual void mouseReleaseEvent(QMouseEvent *event);
    virtual void mouseMoveEvent(QMouseEvent *event);
    virtual void wheelEvent(QWheelEvent *event);
    virtual void keyPressEvent(QKeyEvent *event);

private:
    qreal angle;
    qreal zoom;
    qreal posX;
    qreal posY;
    bool lbutton;
    bool rbutton;
    QPoint ppoint;
    GLuint texture;
    QImage tex;
    bool fit;
signals:

public slots:
    void loadFile(const QString filename);
    void setFitMode(bool checked);


};

#endif // NOPVIEWGLWIDGET_H
