/***************************************************************************
 *   Copyright (C) 2011 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef NOPVIEWRATINGWIDGET_H
#define NOPVIEWRATINGWIDGET_H

#include <QWidget>
#include <QList>
#include <QLabel>

class NopViewRatingWidget : public QWidget
{
    Q_OBJECT
    Q_PROPERTY(int rating READ rating WRITE setRating NOTIFY valueChanged)
public:
    explicit NopViewRatingWidget(QWidget *parent = 0);
    ~NopViewRatingWidget();
    int rating();
    void setRating(int r);
private:
    QList<QLabel *> stars;
    bool pressed;
    int _rating;
protected:
    virtual void mousePressEvent(QMouseEvent *event);
    virtual void mouseReleaseEvent(QMouseEvent *event);
    virtual void mouseMoveEvent(QMouseEvent *event);
private:
    void updateRating();
    void setRatingFromPos(int x);
signals:
    void valueChanged(int);
public slots:

};

#endif // NOPVIEWRATINGWIDGET_H
